/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef ADCDEVICEPROXY_H
#define ADCDEVICEPROXY_H

#include <QObject>

#include "mstream-mreg-dev-global/MstreamMregDevGlobal.h"

#include "AdcStatus.h"

class DeviceIndex;
class DominoDevice;
class QHostAddress;

class AdcDeviceProxy : public MstreamMregDevGlobal
{
    Q_OBJECT
public:
    AdcDeviceProxy(DominoDevice *device, QObject *parent = nullptr);

    void setHostAddress(const DeviceIndex &index, const QHostAddress &address, int ttl);
    bool isConnected() const { return pendingStatus.connected; }

signals:
    void proxySetHostAddress(const DeviceIndex &index, const QHostAddress &address, int ttl); // TODO: hide impl

public slots:
    void deviceStatusUpdated(const AdcStatus &devSt);

private:
    AdcStatus pendingStatus;
};

#endif // ADCDEVICEPROXY_H
