#ifndef DFPFSMMAIN_H
#define DFPFSMMAIN_H

#include <optional>

#include "fsm/DeviceMgrFsm.h"
#include "DfpTask.h"

struct DevFlashProgFsmInput : public DeviceMgrFsmInput
{
    QMap<DeviceIndex, FsmState> deviceStates;
};

class DfpFsmMain : public DeviceMgrFsm
{
    Q_OBJECT
public:
    DfpFsmMain(QObject *p);

public slots:
    void setDevState(const DeviceIndex &index, FsmState devSt);

protected slots:
    virtual bool evaluate() override;

protected:
    virtual void printInputString(QDebug dbg) const override;
    virtual qint64 stateTimeoutMs(const FsmState &state) const override;
    inline DevFlashProgFsmInput *getInput() {
        return static_cast<DevFlashProgFsmInput*>(BaseFsm::getInput());
    }
    inline const DevFlashProgFsmInput *getInput() const {
        return static_cast<const DevFlashProgFsmInput*>(BaseFsm::getInput());
    }
private:
    bool isAllInState(const FsmState &st, const std::optional<FsmState> &st2={}) const;
    bool isAnyInState(const FsmState &st) const;
    FsmState getPrefSt() const;
};

QDebug operator<<(QDebug dbg, const DevFlashProgFsmInput &in);

#endif // DFPFSMMAIN_H
