#include "DreConfig.h"

#include <QJsonDocument>
#include <QJsonObject>
#include <QSettings>

#include "base/ConfigConverterUtil.h"

void DreConfig::loadSettings()
{
    QSettings settings;
    auto jStr = settings.value("config").toString();
    QByteArray data = jStr.toUtf8();
    auto jObj = QJsonDocument::fromJson(data).object();

    QJsonValue cfgJVal = jObj["cfg"];

    DreConfig c1 = QVariant::fromValue(cfgJVal).value<DreConfig>();

    *this = c1;
}

void DreConfig::saveSettings()
{
    QSettings settings;


    auto cfgJVal = QVariant::fromValue(*this).value<QJsonValue>();
    auto cfgJObj = QJsonObject({{"cfg", cfgJVal}});
    auto byteArray = QJsonDocument(cfgJObj)
            .toJson(QJsonDocument::Compact);
    auto str = QString::fromUtf8(byteArray);

    settings.setValue("config", str);
}

std::optional<quint64> RegOpAction::getWriteVal() const
{
    bool ok;

    auto val = writeVal.toULongLong(&ok, 10);
    if(ok)
        return val;

    val = writeVal.toULongLong(&ok, 16);
    if(ok)
        return val;

    return {};
}
