#ifndef SDBCOMBOBOXDELEGATE_H
#define SDBCOMBOBOXDELEGATE_H

#include <QItemDelegate>
#include <optional>

struct DeviceChModelItem;
class QDoubleSpinBox;
class QTimer;
class QComboBox;

class SdbComboBoxDelegate : public QItemDelegate
{
    Q_OBJECT
public:
    SdbComboBoxDelegate(QObject *parent = 0);
    QWidget *createEditor(QWidget *parent,
                          const QStyleOptionViewItem &option,
                          const QModelIndex &index) const;
    void setEditorData(QWidget *editor,
                       const QModelIndex &index) const;
    void setModelData(QWidget *editor,
                      QAbstractItemModel *model,
                      const QModelIndex &index) const;
    void updateEditorGeometry(QWidget *editor,
                              const QStyleOptionViewItem &option,
                              const QModelIndex &index) const;
    void setSdbMap(const QMap<QString, QPair<quint32, quint32> > &sdbMap);
    static void updateCbItems(QComboBox *cb, const QMap<QString, QPair<quint32, quint32> > &map, QList<QVariant> curData = {});

private slots:
    void dataChanged();
//    void flushCommitData();

private:
    inline DeviceChModelItem *getItemByIndex(const QModelIndex &index) const;

//    QTimer * const commitDataTimer;
//    QObject * commitDataWidget = nullptr;
    QMap<QString, QPair<quint32, quint32>> sdbMap;
};

#endif // SDBCOMBOBOXDELEGATE_H
