#ifndef FILEWATCHERFSM_H
#define FILEWATCHERFSM_H

#include "fsm/BaseFsm.h"

struct FileWatcherFsmInput : public BaseFsmInput
{
    bool fileValid;
};

class FileWatcherFsm : public BaseFsm
{
    Q_OBJECT
public:
    explicit FileWatcherFsm(QObject *parent = nullptr);
    virtual bool isTransitionAllowed(const FsmState &toState) const;

public slots:
    void setFileValid(bool valid);

protected slots:
    virtual bool evaluate() override;

protected:
    virtual void printInputString(QDebug dbg) const override;
    inline FileWatcherFsmInput *getInput() {
        return static_cast<FileWatcherFsmInput*>(BaseFsm::getInput());
    }
    inline const FileWatcherFsmInput *getInput() const {
        return static_cast<const FileWatcherFsmInput*>(BaseFsm::getInput());
    }
};

QDebug operator<<(QDebug dbg, const FileWatcherFsmInput &in);

#endif // FILEWATCHERFSM_H
