#ifndef FILEWATCHERSIGNALROUTER_H
#define FILEWATCHERSIGNALROUTER_H

#include "lib-common/BaseSignalRouter.h"

class BaseAppConfigDb;
class FileWatcherConfigDb;
class FileWatcherConfigDispatcher;
class FileWatcherCore;
//class FileWatcherMainWindow;
class ConsoleReader;
class DataSender;
class FileWatcherFsm;
class FileReader;

class FileWatcherSignalRouter : public BaseSignalRouter
{
    FileWatcherSignalRouter();

    Q_DISABLE_COPY_MOVE(FileWatcherSignalRouter)
public:
    // Singleton
    static FileWatcherSignalRouter & instance()
    {
        // thread-safe since C++11
        static FileWatcherSignalRouter obj;
        return obj;
    }

public:
    void setCore(FileWatcherCore *p);
    void setFsm(FileWatcherFsm *p);
    void setFileMonitor(FileReader *p)
    { fileMonitor = p;}
//    void setMainWindow(FileWatcherMainWindow *p)
//    { mainWindow = p; }
    void setConfigDispatcher(FileWatcherConfigDispatcher *p)
    { configDispatcher = p; }
    void setConfigDb(FileWatcherConfigDb *p)
    { configDb = p; }
    void setDataSender(DataSender *p)
    { dataSender = p; }
    void setConsoleReader(ConsoleReader *p)
    { consoleReader = p; }

    void connectAll() const override;

private:
    void connect_ConfigurationDispatcher() const;
    void connect_PnpServer() const override;
    void connect_RemoteControlServer() const override;
    void connect_FSM() const override;
    void connect_ConsoleReader() const;

    FileWatcherConfigDb * configDb = nullptr;
    FileWatcherConfigDispatcher * configDispatcher = nullptr;
    FileWatcherCore * core = nullptr;
    FileWatcherFsm * fsm = nullptr;
    FileReader * fileMonitor = nullptr;
//    FileWatcherMainWindow *mainWindow = nullptr;
    DataSender *dataSender = nullptr;
    ConsoleReader *consoleReader = nullptr;
};

#endif // FILEWATCHERSIGNALROUTER_H
