#ifndef ASSIGNINDEXESDIALOG_H
#define ASSIGNINDEXESDIALOG_H

#include <QDialog>
#include "device-discover/DiscoverDialog.h"
#include "config/HrbAppConfig.h"
#include "base/DeviceIndexEnabled.h"
#include "mldiscover/LldpDiscovery.h"

namespace Ui {
class AssignIndexesDialog;
}
class QComboBox;

class AssignIndexesDialog : public QDialog
{
    Q_OBJECT

public:
    explicit AssignIndexesDialog(DeviceIndexEnabledMap d,
                                 QMap<quint32, QString> hostMap,
                                 QWidget *parent = 0);
    ~AssignIndexesDialog();

    void init(HrbAppConfig ss, bool isHrbType);
    HrbAppConfig getSystemSetup();

private slots:
    void on_pushButtonAutoFill_clicked();
    void on_spinBox_valueChanged(int max);
    void comboBoxChanged(int);
    void setDefaultIndex();

private:
    void setDevices();
    bool isValid();
    bool skipDevice(const DeviceIndexEnabled &dd) const;
    QMap<DeviceIndex, int> getDevMap() const;
    void refreshLabels() const;
    QMap<DeviceIndex, ModularDeviceConfig> getHrbSetups();
    QMap<DeviceIndex, ModularDeviceConfig> getTtbSetups();

    Ui::AssignIndexesDialog *ui;
    LldpInfoCache lldpCache;
    DeviceIndexEnabledMap devices;
    HrbAppConfig config;
    QVector<QComboBox *> boxes;
    QMap<DeviceIndex, QString> labelsMap;
    bool hrbType;
    QMap<quint32, QString> hostMap;

};

#endif // ASSIGNINDEXESDIALOG_H
