//
//    HRB Status Application
//
//    Copyright 2013 AFI Electronics
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//


#include "HrbMainWindow.h"
#include "HrbApp.h"
#include "HrbCore.h"
#include "base/Globals.h"

#include <exception>
#include <QDebug>
//#include <QStyleFactory>

#include "mongo/PrintConfigMap.h"

int main (int argc, char **argv)
{
    int ret = 1;
    Globals::setDaqModuleType(DaqModule::Type::HrbSystem);
    try{
        HrbApp daqApp(argc, argv);
        daqApp.init();

        if(daqApp.hasConfigListOpt())
            printConfigMap();

        HrbMainWindow *mw = nullptr;
        if (daqApp.isGuiApp()) {

            mw = new HrbMainWindow();
            mw->show();
        }
        HrbCore core;

        ret = daqApp.exec();
    } catch (std::exception &e) {
        qDebug() << "Exception: " << e.what ();
    } catch (...){
        qDebug() << "Unknown exception";
    }

    return ret;
}
