#include "MongoViewerConfigDB.h"
#include "MongoViewerConfigConverter.h"

#include <QJsonObject>

MongoViewerConfigDB::MongoViewerConfigDB(QObject *parent)
    : AbstractConfigDb(parent)
    , config(MongoViewerConfig())
{
    AbstractConfigConverter<MongoViewerConfig>::registerTypes();
}

void MongoViewerConfigDB::setConfig(const MongoViewerConfig &newConfig)
{
    if (newConfig == config)
        return;
    config = newConfig;

    QJsonObject obj = QVariant::fromValue(newConfig).value<QJsonObject>();
    writeConfig(getConfigSelector(), obj);
}

void MongoViewerConfigDB::update_config_from_db()
{
    auto cfgJson = BaseConfig::readConfig(cs);
    config = QVariant::fromValue(cfgJson).value<MongoViewerConfig>();
    emit configChanged(config);
}
