#ifndef CLIENTFSM_H
#define CLIENTFSM_H

#include "BaseEvbClientFsm.h"

struct ClientFsmInput : public BaseFsmInput
{
    FsmState tcpState = FsmState::Init;
    FsmState analizerState = FsmState::Init;
};

class ClientFsm : public BaseEvbClientFsm
{
    Q_OBJECT
public:
    explicit ClientFsm(QObject *parent = nullptr);
    void setTcpState(FsmState tcpState);
    void setAnalizerState(FsmState state);

protected:
    virtual void printInputString(QDebug dbg) const override;
    inline ClientFsmInput *getInput() {
        return static_cast<ClientFsmInput*>(BaseFsm::getInput());
    }
    inline const ClientFsmInput *getInput() const {
        return static_cast<const ClientFsmInput*>(BaseFsm::getInput());
    }

private:
    bool checkSubStates(const FsmState &st) const final;
    bool hasAnyError() const final;
};

QDebug operator<<(QDebug dbg, const ClientFsmInput &in);
#endif // CLIENTFSM_H
