#ifndef TLU16SFPWIDGET_H
#define TLU16SFPWIDGET_H

#include <QWidget>

#include "device-modules/Tlu16SfpTrigger/Tlu16SfpTriggerBuildParams.h"
#include "device-modules/Tlu16SfpTrigger/Tlu16SfpTriggerConfig.h"
#include "fsm/FsmState.h"
#include "lib-common/BaseDeviceAppConfig.h"

struct Tlu16SfpTriggerBuildParams;
class Tlu16SfpModel;
class ConfigKey;
class CommonSpinBoxDelegate;

namespace Ui {
class Tlu16SfpWidget;
}

class Tlu16SfpWidget : public QWidget
{
    Q_OBJECT

public:
    explicit Tlu16SfpWidget(QWidget *parent = nullptr);
    ~Tlu16SfpWidget();
    Tlu16SfpModel *getModel() const { return model; }

public slots:
    void updateRemoteBlocking(bool remoteConnected) const;
    void onFsmStateChange(const FsmState &state);

private slots:
    void onModelReset();

private:
    void addDelegate(const QModelIndex &index);

    Ui::Tlu16SfpWidget *ui;
    Tlu16SfpModel * const model;
    CommonSpinBoxDelegate * const thrSbDelegate;
};

#endif // TLU16SFPWIDGET_H
