#ifndef MSCSIGNALROUTER_H
#define MSCSIGNALROUTER_H

#include "lib-common/ReadoutAppSignalRouter.h"

class MscCore;
class MscDevice;
class MscDeviceGlobal;
class MscHistDialog;
class MscHistModel;
class MscMainWindow;
class MscStatusPublisher;
class MscThresholdModel;

class MStreamStatisticWidget;

class MscSignalRouter : public ReadoutAppSignalRouter
{
    MscSignalRouter();
    Q_DISABLE_COPY_MOVE(MscSignalRouter);
public:
    // Singleton
    static MscSignalRouter & instance()
    {
        // thread-safe since C++11
        static MscSignalRouter obj;
        return obj;
    }

    void setCore(MscCore *p);
    void setMainWindow(MscMainWindow *p);
    void setMStreamStatisticWidget(MStreamStatisticWidget *p) { mstreamStatisticWidget = p; }
    void setStatusPublisher(MscStatusPublisher *p) { statusPublisher = p; }
    void setHistDialog(MscHistDialog *p) { histDialog = p; }
    void setHistModel(MscHistModel *p) { histModel = p; }
    void setTresholdModel(MscThresholdModel *p) { thresholdModel = p; }

    void connect_MainWindow() const override;
    void connect_MscDevice(const MscDeviceGlobal *dg, const MscDevice *dev) const;
    void connect_FSM() const override;

private:

    MStreamStatisticWidget * mstreamStatisticWidget = nullptr;

    MscCore * core = nullptr;
    MscHistDialog * histDialog = nullptr;
    MscHistModel * histModel = nullptr;
    MscMainWindow * mainWindow = nullptr;
    MscStatusPublisher * statusPublisher  = nullptr;
    MscThresholdModel * thresholdModel = nullptr;
};

#endif // MSCSIGNALROUTER_H
