/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef TRIGCORE_H
#define TRIGCORE_H

#include <QObject>

class DeviceDispatcher;
class RcConfigDispatcher;
class TrigDeviceController;

class TrigCore : public QObject
{
    Q_OBJECT
public:
    explicit TrigCore(QObject *parent = nullptr);
    virtual ~TrigCore(){};
    void setConfigDispatcher(RcConfigDispatcher *p);
    DeviceDispatcher* getDeviceDispatcher() { return deviceDispatcher; }
    TrigDeviceController* getTrigDeviceController() { return trigDeviceController; }

signals:
    void printFsmInput();

private:
    DeviceDispatcher * const deviceDispatcher;
    TrigDeviceController * const trigDeviceController;
};

#endif // TRIGCORE_H
