#include "TqdcDeviceGlobal.h"

#include "TqdcDevice.h"
#include "TqdcSignalRouter.h"

TqdcDeviceGlobal::TqdcDeviceGlobal(const DeviceIndex &index, QObject *parent)
    :
    MstreamMregDevGlobal(new TqdcDevice(index), pendingDevStatus, parent)
    , pendingDevStatus(index)
{
    auto device = getDevice<TqdcDevice>();
    connect(device, &TqdcDevice::statusUpdated,
            this, &TqdcDeviceGlobal::deviceStatusUpdated);
    TqdcSignalRouter::instance().connect_TqdcDeviceGlobal(this, device);
}

void TqdcDeviceGlobal::deviceStatusUpdated(const TqdcStatus &status)
{
    Q_ASSERT(getDeviceIndex() == status.getDeviceIndex());
    if (getDeviceIndex() != status.getDeviceIndex())
        return;

    pendingDevStatus = status;
}
