#include "BusySourceGroupBox.h"
#include "ui_BusySourceGroupBox.h"

BusySourceGroupBox::BusySourceGroupBox(QWidget *parent) :
    QGroupBox(parent),
    ui(new Ui::BusySourceGroupBox)
{
    ui->setupUi(this);
    updateGui();
}

BusySourceGroupBox::~BusySourceGroupBox()
{
    delete ui;
}

void BusySourceGroupBox::setConfig(ConfigKey, const RunControlAppConfig &config_)
{
    if(config == config_)
        return;
    bool changed = config.defaultSetup.ttvxsCore.busySource
            != config_.defaultSetup.ttvxsCore.busySource;
    config = config_;
    if(changed)
        updateGui();
}

void BusySourceGroupBox::on_checkBoxPulse_toggled(bool vxsPulse)
{
    config.defaultSetup.ttvxsCore.busySource.vxsPulse = vxsPulse;
    config.unify_config();
    emit configChanged(config);
}


void BusySourceGroupBox::on_checkBoxFeLink_toggled(bool vxsFeLink)
{
    config.defaultSetup.ttvxsCore.busySource.vxsFeLink = vxsFeLink;
    config.unify_config();
    emit configChanged(config);
}

void BusySourceGroupBox::updateGui() const
{
    QSignalBlocker b1(ui->checkBoxPulse);
    QSignalBlocker b2(ui->checkBoxFeLink);
    ui->checkBoxPulse->setChecked(config.defaultSetup.ttvxsCore.busySource.vxsPulse);
    ui->checkBoxFeLink->setChecked(config.defaultSetup.ttvxsCore.busySource.vxsFeLink);
}

