#include "TtvxsDeviceGlobal.h"

#include "TtvxsDevice.h"
#include "TtvxsAppConfigDispatcher.h"

TtvxsDeviceGlobal::TtvxsDeviceGlobal(const DeviceIndex &index, QObject *parent)
    : MstreamMregDevGlobal(new TtvxsDevice(index), prev_status, parent)
{
    auto dev = getDevice<TtvxsDevice>();

    connect(this, &TtvxsDeviceGlobal::resetTimestamp, dev, &TtvxsDevice::resetTimestamp);
    connect(this, &TtvxsDeviceGlobal::clearStat, dev, &TtvxsDevice::clearStat);
    connect(this, &TtvxsDeviceGlobal::evNumReset, dev, &TtvxsDevice::evNumReset);
    connect(this, &TtvxsDeviceGlobal::softClear, dev, &TtvxsDevice::softClear);
    connect(this, &TtvxsDeviceGlobal::restartAll, dev, &TtvxsDevice::onRestartAll);

    TtvxsAppConfigDispatcher::instance().forwardDeviceConfig(dev);
    connect(dev, &TtvxsDevice::statusUpdated, this, &TtvxsDeviceGlobal::statusUpdated);
    connect(dev, &ModularMregDevice::feLinkStatusUpdated, this, &TtvxsDeviceGlobal::feLinkStatusUpdated);
    connect(this, &TtvxsDeviceGlobal::getTrigEvNum, dev, &TtvxsDevice::getTrigEvNum);
    connect(dev, &TtvxsDevice::topEvNumResponse, this, &TtvxsDeviceGlobal::topEvNumResponse);
    connect(dev, &TtvxsDevice::evNumResponse, this, &TtvxsDeviceGlobal::evNumResponse);
}

void TtvxsDeviceGlobal::statusUpdated(const TtvxsStatus &status)
{
    if(getDeviceIndex() != status.getDeviceIndex())
        return;
    emit statusUpdated_(status, prev_status);
    prev_status = status;
}
