#include "AfiViewerApp.h"

#include <QCommandLineParser>
#include <QCoreApplication>
#include <QPixmap>

AfiViewerApp::AfiViewerApp(int &_argc, char *_argv[])
    : DaqGuiApp(_argc, _argv),
      inl_option(QStringList() << "i" << "inl",
                 QCoreApplication::translate("main", "Enables save INL correction")),
      file_option(QStringList() << "f" << "file",
                 QCoreApplication::translate("main", "Sets initial source file"), "filePath")
{
}

void AfiViewerApp::setupOptions()
{
    DaqGuiApp::setupOptions();
    options << inl_option;
    options << file_option;
}

void AfiViewerApp::processParseResults(QCommandLineParser &parser)
{
    DaqGuiApp::processParseResults(parser);

    so.inl = parser.isSet(inl_option);
    if(parser.isSet(file_option)) {
        so.fileName = parser.value(file_option);
    }
}

QPixmap AfiViewerApp::getSplashPixmap() const
{
    return DaqGuiApp::getSplashPixmap();
}
