#include "TableHelper.h"

#include <QHeaderView>
#include <QTableWidget>
#include <QScrollBar>

void TableHelper::updateTableSize(QTableWidget * const table, bool widthOnly)
{
    table->resizeRowsToContents();
    table->resizeColumnsToContents();
//    table->setColumnWidth(COL_RATE, 500);

    int width = table->verticalHeader()->width()+5;
    for(int col=0; col<table->columnCount(); ++col) {
        if(table->isColumnHidden(col))
            continue;
        width += table->columnWidth(col);
    }
    if(width<20)
        width = 20;

    int height = table->horizontalHeader()->height()+5;
    for(int row=0; row<table->rowCount(); ++row) {
        if(table->isRowHidden(row))
            continue;
        height += table->rowHeight(row);
    }
    if(height<20)
        height = 20;
    if(widthOnly) {
        width += table->verticalScrollBar()->width();
        table->setMinimumWidth(width);
    } else
        table->setFixedSize(width, height);
    table->updateGeometry();
}
