/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef DAQGUIAPPPRIVATE_H
#define DAQGUIAPPPRIVATE_H

#include <QCoreApplication>
#include <QSharedPointer>

class QSplashScreen;

class DaqGuiApp;

class DaqGuiAppPrivate {
public:
    DaqGuiAppPrivate(int &argc, char *argv[], DaqGuiApp *p);

private:
    Q_DISABLE_COPY(DaqGuiAppPrivate)
    Q_DECLARE_PUBLIC(DaqGuiApp)

    QCoreApplication *createApplication(int &argc, char *argv[]);

    DaqGuiApp * const q_ptr;
    QSharedPointer<QSplashScreen> splash;
};

#endif // DAQGUIAPPPRIVATE_H
