/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef DEVICESTATUSUTIL_H
#define DEVICESTATUSUTIL_H

#include <QMap>
#include <QStringList>

class DeviceIndex;

template<class T>
QString deviceStateSummary(const QMap<DeviceIndex, T> &dev_status)
{
    QStringList summary;
    QStringList list;
    for (auto it = dev_status.begin(); it != dev_status.end(); ++it) {
        if (!it.value().connected)
            list << it.key().toString();
    }
    if (!list.empty())
        summary << "Devices not connected (" + list.join(", ") + ")";

    return summary.join("\n");
}

#endif // DEVICESTATUSUTIL_H
