
#ifndef SDBMODULEINDEX_H
#define SDBMODULEINDEX_H

#include <cstdint>
#include <tuple>

enum AFI_SDB_ID : uint32_t;

struct SdbModuleIndex
{
    SdbModuleIndex() = default;
    SdbModuleIndex(uint32_t baseAddr, AFI_SDB_ID id) : baseAddr(baseAddr), id(id) {}

    friend bool operator==(const SdbModuleIndex &, const SdbModuleIndex &) = default;
    friend auto operator<=>(const SdbModuleIndex &l, const SdbModuleIndex &r) {
        return std::tie(l.baseAddr, l.id) <=> std::tie(r.baseAddr, r.id);
    }

    bool isNull() const {
        return *this == SdbModuleIndex{};
    }

    uint32_t baseAddr = 0;
    AFI_SDB_ID id = {};
};

#endif // SDBMODULEINDEX_H
