#ifndef CALCONFIG_H
#define CALCONFIG_H

#include <QString>
#include <QMap>
#include <QMetaType>

#include "CalResult.h"
#include <optional>

class DeviceIndex;
class QSettings;

class CalConfig : public QMap<DeviceIndex, CalResult>
{
public:
    enum class Type { Baseline, Rms, Baseline4, Rms4, Dac};
    void updateBaseCal(const CalResult &calRes);
    void reloadCalibration();
    void writeAll();
    std::optional<double> getValue(Type type, const DeviceIndex &index, int channel) const;

protected:
    void reloadCalibration(QSettings &s);
};
Q_DECLARE_METATYPE(CalConfig)

#endif // CALCONFIG_H
