/*
**    Copyright 2009-2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef DSPLIB_FITTERSINE_H
#define DSPLIB_FITTERSINE_H

#include "FitterBase.h"

#ifdef USE_FFT
#include "rfftw.h"
#endif

namespace dsplib {

enum { MAX_FITSINE_POINTS = 1000 };

class FitterSine : public FitterBase
{
public:
    explicit FitterSine (unsigned int fit_points);
    int fit (int fixpar, const double *x, int len, double *par0, double *par, fitstatus_t *fs);
protected:
#ifdef USE_FFT
    fftw_plan fftw_p;
    rfftw_plan fftwr_p;
    int fftw_p_size;
#endif
};

} // namespace dsplib

#endif // DSPLIB_FITTERSINE_H
