#include "FsmState.h"

#include <QDebug>
#include <QList>

namespace {
const static QMap<FsmState, QString> FsmStateStringMap = {
    {FsmState::Unknown,         "Unknown"},
    {FsmState::Init,            "Init"},
    {FsmState::Error,           "Error"},
    {FsmState::Ready,           "Ready"},
    {FsmState::Configure,       "Configure"},
    {FsmState::Starting,        "Starting"},
    {FsmState::Run,             "Run"},
    {FsmState::Stopping,        "Stopping"},
    {FsmState::Calibrate,       "Calibrate"},
    {FsmState::FindAdcDelay,    "FindAdcDelay"},
    {FsmState::CloseGlobTrig,   "CloseGlobTrig"},
    {FsmState::WaitSpillEnd,    "WaitSpillEnd"},
    {FsmState::OpenGlobTrig,    "OpenGlobTrig"},
    {FsmState::PrepareStopping, "PrepareStopping"},
};
}

QString fsmStateToString(const FsmState &state)
{
    auto it = FsmStateStringMap.find(state);
    if(it!=FsmStateStringMap.end())
        return it.value();
    return FsmStateStringMap[FsmState::Unknown];
}


FsmState getFsmState(const QString &str)
{
    auto it = FsmStateStringMap.key(str, FsmState::Unknown);
    return it;
}

uint qHash(const FsmState &r, uint seed) {
    return qHash(static_cast<uint>(r), seed);
}

QDebug operator <<(QDebug stream, const FsmState &state)
{
    stream.noquote().nospace() << fsmStateToString(state);
    return stream;
}
