/*
**    Copyright 2015 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef TRIGGERHISTOGRAM_H
#define TRIGGERHISTOGRAM_H

#include <optional>
#include <QWidget>

namespace Ui {
class TriggerHistogram;
}

struct TriggerHistogramData;
class WaveformPlot;

class TriggerHistogram : public QWidget
{
    Q_OBJECT

public:
    explicit TriggerHistogram(QWidget *parent = nullptr);
    ~TriggerHistogram();

public slots:
    void updateHistogram(const TriggerHistogramData &thd);
    void setPlotCh(int ch);

private slots:
    void checkForReplot();

private:
    void scheduleReplot();
    void performReplot();

    Ui::TriggerHistogram *ui;
    WaveformPlot *plot;
    QList<TriggerHistogramData> history;
    bool replot = true;
    std::optional<int> plotCh;
};

#endif // TRIGGERHISTOGRAM_H
