#ifndef ADCSPILTM9011MODULE_H
#define ADCSPILTM9011MODULE_H

#include "BaseDeviceModule.h"
#include "device-modules/AdcSpiBaseModule.h"

class AdcSpiLtm9011Module : public BaseDeviceModule<AdcSpiLtm9011Module>, public AdcSpiBaseModule
{
public:
    explicit AdcSpiLtm9011Module(const MregBusInterface &bus);

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool setupAdc() override;
    bool setCustomPatternMode(bool mode) override;
    bool setCustomPattern(quint16 data) override;

private:
    inline int getReadReg(quint8 adcId = 0) const;
    inline int getWriteReg(quint8 adcId = 0) const;
    inline int getAddrReg(quint8 adcId = 0) const;

    bool spi_write(quint16 addr, quint16 data, quint8 adcId);
    bool spi_read(quint16 addr, quint16 *result, quint8 adcId);
    bool spi_test_impl(TestResult *result) override;
};

#endif // ADCSPILTM9011MODULE_H
