/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef BOARDGPIOMODULE_H
#define BOARDGPIOMODULE_H

#include <optional>
#include "BoardGpio/BoardGpioStatus.h"
#include "device-modules/BaseDeviceModule.h"

class BoardGpioConfig;

class BoardGpioModule : public BaseDeviceModule<BoardGpioModule>
{
public:
    explicit BoardGpioModule(const MregBusInterface &bus);

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool writeConfig(const BoardGpioConfig &newConfig);

    bool readStatus(BoardGpioStatus *result);
    std::optional<BoardGpioStatus> readStatus();

private:
    bool readBuildParams();

    BoardGpioStatus status;
};

#endif // BOARDGPIOMODULE_H
