#ifndef DDR3STREAMFIFOMODULE_H
#define DDR3STREAMFIFOMODULE_H

#include <optional>

#include "device-modules/BaseDeviceModule.h"

struct Ddr3StreamFifoStatus;

class Ddr3StreamFifoModule : public BaseDeviceModule<Ddr3StreamFifoModule>
{
public:
    explicit Ddr3StreamFifoModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    std::optional<Ddr3StreamFifoStatus> readStatus();
    bool readStatus(Ddr3StreamFifoStatus *result);

private:
    mlink::RegOpVector getStatusRegOp(Ddr3StreamFifoStatus *result) const;
};

#endif // DDR3STREAMFIFOMODULE_H
