#ifndef FIRFILTERMODULE_H
#define FIRFILTERMODULE_H

#include <optional>

#include "FirFilter/FirFilterBuildParams.h"
#include "FirFilter/FirFilterStatus.h"
#include "device-modules/BaseDeviceModule.h"

class FirFilterConfig;
namespace mlink { class RegOpVector; }

class FirFilterModule : public BaseDeviceModule<FirFilterModule>
{
public:
    explicit FirFilterModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();
    virtual void post_init() override;

    std::optional<FirFilterBuildParams> getBuildParam() const
    {
        return buildParams;
    }

    bool writeConfig(const FirFilterConfig &fir);
    std::optional<FirFilterStatus> readStatus();
    bool readStatus(FirFilterStatus *result);

private:
    std::optional<FirFilterBuildParams> buildParams;
};

#endif // FIRFILTERMODULE_H
