#ifndef STATPRESET_H
#define STATPRESET_H

#include <QList>
#include <QString>
#include <QVector>
#include <QMetaType>

struct StatPreset
{
    enum STAT_TYPE {STAT_DEFAULT,
                    STAT_DEBUG,
                    STAT_Test,
                    STAT_PRESET_CNT};
    StatPreset();

    friend bool operator==(const StatPreset &l, const StatPreset &r) = default;

    STAT_TYPE type;
    QString label;
    QVector<quint16> regs;
};
Q_DECLARE_METATYPE(StatPreset)

class StatPresetFabric
{
public:
    static StatPreset getPreset(int type);
    static StatPreset getPreset(const QString &label);
    static QList<StatPreset> getAllPresets();
};

#endif // STATPRESET_H
