#ifndef TDCCORESTATUS_H
#define TDCCORESTATUS_H

#include <QVector>
#include <QMap>
#include <QMetaType>

#include "base/Severity.h"

struct HptdcStatus
{
    friend bool operator==(const HptdcStatus &l, const HptdcStatus &r) = default;

    bool isOk() const;
    bool isDllLock() const;
    bool hasError() const;
    QString getSummary() const;

    static constexpr const int regCount = 4;
    std::array<quint16, regCount> regValues = {};
};

struct TdcCoreStatus
{
    friend bool operator==(const TdcCoreStatus &l, const TdcCoreStatus &r) = default;

    QString getSummary() const;
    Severity getHptdcSeverity() const;
    bool hasHptdcErr() const;
    inline quint16 getHptdcError() const { return (generalStatus>>16) & 0x1FF; }

    quint32 generalStatus = 0;
    QVector<HptdcStatus> hptdcStatus;
};
Q_DECLARE_METATYPE(TdcCoreStatus)

#endif // TDCCORESTATUS_H
