#include "Tlu16SfpTriggerConfigConverter.h"

#include "Tlu16SfpTriggerConfig.h"

namespace {
// Tlu16SfpTriggerConfig
constexpr const char *k_tofSumThr = "tofSumThr";
constexpr const char *k_tofChEn = "tofChEn";
constexpr const char *k_lumChEn = "lumChEn";
}

// -------------- Tlu16SfpTriggerConfig
template<>
bool AbstractConfigConverter<Tlu16SfpTriggerConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<Tlu16SfpTriggerConfig>::toJsonObject(const Tlu16SfpTriggerConfig &in)
{
    QVariantMap m;
    m[k_tofChEn] = ConfigConverterUtil::toJsonValue(in.tofChEn);
    m[k_lumChEn] = ConfigConverterUtil::toJsonValue(in.lumChEn);
    m[k_tofSumThr] = QVariant::fromValue(in.tofSumThr);
    return fromVariantMap(m);
}

template<>
Tlu16SfpTriggerConfig AbstractConfigConverter<Tlu16SfpTriggerConfig>::fromJsonObject(const QJsonObject &in)
{
    Tlu16SfpTriggerConfig out;
    out.tofChEn = ConfigConverterUtil::toVector<bool>(in[k_tofChEn]);
    out.lumChEn = ConfigConverterUtil::toVector<bool>(in[k_lumChEn]);
    update_value(in, k_tofSumThr, &out.tofSumThr);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<Tlu16SfpTriggerConfig>::toJsonValue(const Tlu16SfpTriggerConfig &in)
{
    return toJsonObject(in);
}

template<>
Tlu16SfpTriggerConfig AbstractConfigConverter<Tlu16SfpTriggerConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<Tlu16SfpTriggerConfig>::registerSubTypes()
{
}
