#ifndef TRIGCTRLSTATSTATUS_H
#define TRIGCTRLSTATSTATUS_H

#include <QtCore>
#include <QMetaType>

struct TrigCtrlBuildParams
{
    friend bool operator==(const TrigCtrlBuildParams &, const TrigCtrlBuildParams &) = default;
    quint32 sourceCaps = ~0u;
    quint32 polarityCaps = ~0u;
    quint32 timerClock = 125'000'000; // in Hz
};
Q_DECLARE_METATYPE(TrigCtrlBuildParams)

struct TrigCtrlStatStatus
{
    friend bool operator==(const TrigCtrlStatStatus &, const TrigCtrlStatStatus &) = default;
    bool isValid() const;

    quint32 id = 0;
    quint32 sourceCaps = ~0u;
    quint16 trigQueue = 0;
    quint16 busyStatus = 0;
};

#endif // TRIGCTRLSTATSTATUS_H
