/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef AD5328CONFIGBUILDER_H
#define AD5328CONFIGBUILDER_H

#include "Ad5328/Ad5328Config.h"

class Ad5328ConfigBuilder
{
public:
    virtual ~Ad5328ConfigBuilder() = default;
    virtual Ad5328Config build(const QMap<int, int> &values) const = 0;

protected:
    struct ChannelIndex {
        int chip;
        int chipChannel;
    };
    virtual ChannelIndex mapChannel(int channel) const = 0;
};

#endif // AD5328CONFIGBUILDER_H
