#ifndef DACCALIBRATION_H
#define DACCALIBRATION_H

#include "AbstractThresholdCalibrator.h"

#include <optional>
#include <QMap>
#include <QSharedPointer>

class HitCoreModule;
class Ad5328ConfigBuilder;
class Ad5328Module;

class DacCalibration : public AbstractThresholdCalibrator
{
public:
    explicit DacCalibration(const Ad5328ConfigBuilder &dacConfigBuilder) : dacConfigBuilder(dacConfigBuilder) {}
    void setModules(QSharedPointer<HitCoreModule> hitCore,
                    QSharedPointer<Ad5328Module> thresholdModule)
    {
        this->hitCore = hitCore;
        this->thresholdMod = thresholdModule;
    }

protected:
    bool writeLevels(const QMap<int, int> &values) override;
//    bool readStates(QVector<double> *states) override;

private:
//    std::optional<QVector<bool> > getChStates();

    QSharedPointer<HitCoreModule> hitCore;
    QSharedPointer<Ad5328Module> thresholdMod;
    const Ad5328ConfigBuilder &dacConfigBuilder;

    const int num_samples = 20;
};

#endif // DACCALIBRATION_H
