#include "AdcMpdTrigPolarityWidget.h"
#include "ui_AdcMpdTrigPolarityWidget.h"

AdcMpdTrigPolarityWidget::AdcMpdTrigPolarityWidget(QWidget *parent) :
    QWidget(parent), ui(new Ui::AdcMpdTrigPolarityWidget)
{
    ui->setupUi(this);
    for(auto v : {ui->radioButtonPos, ui->radioButtonNeg}) {
        connect(v, &QRadioButton::toggled, this, &AdcMpdTrigPolarityWidget::sendState);
        v->setAutoExclusive(false);
    }
}

AdcMpdTrigPolarityWidget::~AdcMpdTrigPolarityWidget()
{
    delete ui;
}

void AdcMpdTrigPolarityWidget::setState(Qt::CheckState st) const
{
    ui->radioButtonNeg->setChecked(st == Qt::Checked);
    ui->radioButtonPos->setChecked(st == Qt::Unchecked);
}

Qt::CheckState AdcMpdTrigPolarityWidget::currentState() const
{
    if(ui->radioButtonPos->isChecked()) return Qt::Unchecked;
    if(ui->radioButtonNeg->isChecked()) return Qt::Checked;
    return Qt::PartiallyChecked;
}

void AdcMpdTrigPolarityWidget::sendState(bool st) const
{
    if(st) {
        (sender()==ui->radioButtonNeg ? ui->radioButtonPos : ui->radioButtonNeg)
        ->setChecked(false);
        emit stateChanged();
    }
}
