#ifndef SPINBOXDELEGATE_H
#define SPINBOXDELEGATE_H

#include <QItemDelegate>

struct DeviceChModelItem;
class QSpinBox;

class SpinBoxDelegate : public QItemDelegate
{
Q_OBJECT
public:
    SpinBoxDelegate(QObject *parent = 0);
    QWidget *createEditor(QWidget *parent,
                          const QStyleOptionViewItem &option,
                          const QModelIndex &index) const;
    void setEditorData(QWidget *editor,
                       const QModelIndex &index) const;
    void setModelData(QWidget *editor,
                      QAbstractItemModel *model,
                      const QModelIndex &index) const;
    void updateEditorGeometry(QWidget *editor,
                              const QStyleOptionViewItem &option,
                              const QModelIndex &index) const;

    virtual void initSpinBox(QSpinBox *s) const {}

private slots:
    void dataChanged();
    void flushCommitData();

private:
    inline DeviceChModelItem *getItemByIndex(const QModelIndex &index) const;

    QTimer * const commitDataTimer;
    QObject * commitDataWidget = nullptr;
};

class AnlgThrSpinBoxDelegate : public SpinBoxDelegate
{
    Q_OBJECT
public:
    AnlgThrSpinBoxDelegate(QObject *p = 0) : SpinBoxDelegate(p) {}
    virtual void initSpinBox(QSpinBox *s) const override
    { initAnlgSpinBox(s); }
    static void initAnlgSpinBox(QSpinBox *s);
};

class DigThrSpinBoxDelegate : public SpinBoxDelegate
{
    Q_OBJECT
public:
    DigThrSpinBoxDelegate(QObject *p = 0) : SpinBoxDelegate(p) {}
    virtual void initSpinBox(QSpinBox *s) const override;
};

#endif // SPINBOXDELEGATE_H
