//
//    Copyright 2015 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef TEXTTABLESTATS_H
#define TEXTTABLESTATS_H

#include <QMap>
#include <QString>
#include <QMetaType>
#include <QDebug>

class TextTableStats : public QMap<QString, qint64> {
public:
    void inc(const QString &key, qint64 value = 1) {
        (*this)[key] += value;
        qDebug() << QString("stats: %1 = %2").arg(key).arg((*this)[key]);
    }
};

Q_DECLARE_METATYPE(TextTableStats)

#endif // TEXTTABLESTATS_H
