/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "AbstractSignalRouter.h"

#include <QtGlobal>

#include "mldiscover/DeviceDispatcher.h"
#include "mldiscover/LldpDiscovery.h"

LldpDiscovery &AbstractSignalRouter::lldpDiscovery()
{
    return LldpDiscovery::instance();
}

void AbstractSignalRouter::connectAll()
{
    connect_deviceDispatcher();
    connect_PnpServer();
    connect_RemoteControlServer();
}

void AbstractSignalRouter::connect_deviceDispatcher()
{
    if(!deviceDispatcher)
        return;
    auto &lldpDiscovery = LldpDiscovery::instance();
    emit lldpDiscovery.setDeviceIdFilter(supportedDeviceIds());
    lldpDiscovery.subscribe(deviceDispatcher);
}
