/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "RcClientProtoVersions.h"

QString getProtocolIdStr(RC_CLIENT_PROTO_ID id, bool shortStr)
{
    switch (id) {
    case RC_CLIENT_PROTO_V1:
        return shortStr ? "v1" : "v1 ASCII str";
    case RC_CLIENT_PROTO_V2:
        return shortStr ? "v2" : "v2 Short sync-word";
    case RC_CLIENT_PROTO_V3:
        return shortStr ? "v3" : "v3 Long sync-word";
    case RC_CLIENT_PROTO_V4:
        return shortStr ? "v4" : "v4 Long sync-word (no checksum)";
    case RC_CLIENT_PROTO_V5:
        return shortStr ? "v5" : "v5 TLV-block with JSON inside";
    default:
        return shortStr ? "unk": "unknown";
    }
}
