#ifndef CMSUBDIALOG_H
#define CMSUBDIALOG_H

#include "base/ConfigIndexName.h"
#include "base/DaqModule.h"
#include "mongo/BaseConfig.h"

#include <QDialog>
#include <QMap>

namespace Ui {
class CMSubDialog;
}
class QAbstractButton;
class ConfigSelector;

enum CMDialogType {
    CMDialog_Type_New,
    CMDialog_Type_Rename,
    CMDialog_Type_Clone
};

class CMSubDialog : public QDialog
{
    Q_OBJECT
public:
    explicit CMSubDialog(const CMDialogType &type,
                         const QJsonObject &cfg_json,
                         const DaqModule &_program_type,
                         const ConfigIndexName &conf,
                         QWidget *parent = nullptr);
    ~CMSubDialog() override;
    ConfigSelector getConfigSelector() const;

signals:
    void switch_to_config(const ConfigIndexName &conf) const;

private slots:
    void on_line_edit_program_index_textEdited(const QString &arg1);
    void on_line_edit_config_name_textChanged(const QString &arg1);
    void on_button_box_ok_cansel_clicked(QAbstractButton *button);

private:
    void check_input_validity();
    QString typeStr() const;

    Ui::CMSubDialog *ui;
    const CMDialogType type;
    QJsonObject default_cfg_json;
    DaqModule program_type;
    ConfigIndexName configuration;
    ConfigIndexName configuration_entered;

    QMap<ProgramIndex, QMap<ConfigurationName, QDateTime> > config_map;
    BaseConfig base_config;
};

#endif // CMSUBDIALOG_H
