#ifndef ZMQTYPES_H
#define ZMQTYPES_H

#include <QMetaType>

class QDataStream;
class QDebug;

// ØMQ

struct ZmqConfig
{
    friend bool operator==(const ZmqConfig &, const ZmqConfig &) = default;

    bool auto_port=true;
    int port=33307;
    bool enabled=false;
    bool test_mode=false;
    bool send_all=false;
    bool print_messages=false;
};
Q_DECLARE_METATYPE(ZmqConfig)

QDebug operator<<(QDebug dbg, const ZmqConfig &s);
QDataStream &operator<<(QDataStream &out, const ZmqConfig &r);
QDataStream &operator>>(QDataStream &in, ZmqConfig &r);

struct ZmqStatus
{
    friend bool operator==(const ZmqStatus &, const ZmqStatus &) = default;

    int port=0; // use as return value in case of autodetect
    bool working=false;
    quint64 packages=0;
};
Q_DECLARE_METATYPE(ZmqStatus)

#endif // ZMQTYPES_H
